function p = flow(s,p,rng)

% flow points p with deformation map given in s
% p must be 3*N
% s is the returned value of a call to measmatch function
%
% author : Joan Glaunès - joan.glaunes@free.fr

loadstruct('s')

mom1 = mom(:,:,1);
mom2 = mom(:,:,2);
mom3 = mom(:,:,3);

if nargin == 2
    rng = 1:T-1;
end

N = size(p,2);

if rng(1) == 1
    % additional affine transformation
    p = transmatrix * p + repmat(transvector,1,size(p,2));
end

p1 = p(1,:);
p2 = p(2,:);
p3 = p(3,:);

for t = rng
    for l = 1:N
        pdot1 = 0;
        pdot2 = 0;
        pdot3 = 0;
        for k = (t-1)*nx+1:t*nx
            greenp = 1/(1-(-( ...
                (X1(k)-p1(l))^2 + ...
                (X2(k)-p2(l))^2 + ...
                (X3(k)-p3(l))^2)/sigmaV2(t)));
            pdot1 = pdot1 + greenp*mom1(k);
            pdot2 = pdot2 + greenp*mom2(k);
            pdot3 = pdot3 + greenp*mom3(k);
        end
        p1(l) = p1(l) + tau*pdot1;
        p2(l) = p2(l) + tau*pdot2;
        p3(l) = p3(l) + tau*pdot3;
    end
end

p = [p1;p2;p3];
