function s = measmatch(s)

% Measure matching algorithm
%
% s : input and output structure,
% see file setparams.m for explanations
%
% author : Joan Glaunès - joan.glaunes@free.fr

% set parameters
s = setparams(s);

% initialization
s = initialize(s);

loadstruct('s')
clear s

% graphical handles
ghandle = 0;

% call to optimization routine
eval(['[mom,J] = ',useoptim,'(mom,@functional,@grad,optim,',functional,');']);

% compute trajectories
[X1,X2,X3] = comptraj(xrig,mom,T,sigmaV2);

savestruct('s',vars)
